#include "Header.hh"

void Growth(int time)
{
  int i,j,q;
  int H;
  double P;
  int Hdiv=2*M1;
  int Hdivlrc=4*M1;
  int Hmax=144/xstep;
  int meani,mini,maxi,meanj;
  int tgrowth;
  int growconst=(int)(20*60*60/(Hdiv+1-M1));
  int elongconst=(int)(7.8*60*60/(Hmax-M1));


  if(time==0)
    {
      for(q=0;q<totcells;q++)
	TimePrevGrowth[q]=time;
    }

  

  for(i=0;i<totcells;i++)
    JustChecked[i]=0;
  
  if(time%tcleargrowth==0)
    {
      for(i=0;i<n;i++)
	for(j=0;j<m;j++)
	  GrowthRate[i][j]=0;
    }
  if(time%tcleardiv==0)
    {
      for(i=0;i<n;i++)
	for(j=0;j<m;j++)
	  DivRate[i][j]=0;
    }


  double rdivaux;
  double relong;
  for(q=0;q<actcells;q++)
    {
      Rgrow[q]=0;
      Rgrowavg[q]=0;
    }
  //cell based Rgrow
  for(q=0;q<actcells;q++)
    {
#ifdef PLTDEPZONATION
      if(Plts[q]>=40 || CellMaxJ[q]<5*M1+(5*2)/xstep)
#else
      if(CellMinJ[q]<49 || CellMaxJ[q]<5*M1+(5*2)/xstep)
#endif
	{
	  Rgrow[q]=0.0000001;
	}
#ifdef PLTDEPZONATION
      else if(Plts[q]>15 )
#else
      else if(CellMinJ[q]<500)//<210)
#endif
	{
#ifdef ARFDEPRATES 
	  rdivaux=0.0000273;
	  if(ARF[q]<3)
	    Rgrow[q]=(rdivaux*16)/(16+(ARF[q]-3)*(ARF[q]-3));
	  else if(ARF[q]<60)
	    Rgrow[q]=rdivaux;
	  else
	    Rgrow[q]=(rdivaux*12.25)/(12.25+(ARF[q]-60)*(ARF[q]-60));
#else
	  rdivaux=10*0.000022;//!!!!
	  Rgrow[q]=rdivaux;
#endif
	}
      else
	{
	  if(CellHeight[q]<Hmax && Diff[q]<85)
	    {
#ifdef ARFDEPRATES     
	      relong=0.000104635;
	      if(ARF[q]<0.5)
		Rgrow[q]=relong*(4/(4+(ARF[q]-0.5)*(ARF[q]-0.5)));
	      else if(ARF[q]<8)
		Rgrow[q]=relong;
	      else
		Rgrow[q]=relong*(9/(9+(ARF[q]-8)*(ARF[q]-8)));
#else
#ifdef LIMITEDARFDEPRATES
	      relong=0.000104635;
	      if(ARF[q]<8)
		Rgrow[q]=relong;
	      else
		Rgrow[q]=relong*(9/(9+(ARF[q]-8)*(ARF[q]-8)));
#else
	      relong=10*0.000104635;//!!!
	      Rgrow[q]=relong;
#endif
#endif
	    }
	  else
	    Rgrow[q]=0.0000001;
	}
    }


  int it;
  int nrit=1;
  int w1,w2,w3;
  int qq;
  int count;
  for(it=0;it<nrit;it++)
    {
      //use Rgrow to find Rgrowavg;
      for(q=0;q<actcells;q++)
	{
	  w1=1;
	  w2=1;
	  w3=1;
	  
	  meani=CellMinI[q]+(N/2);
	  if(meani<1+N)//left epidermal
	    {
	      w1=0;
	      w2=5;//*5;
	      w3=4;//*4;
	    }
	  else if(meani>n-N-2)//right epidermal
	    {
	      w1=4;//*4;
	      w2=5;//*5;
	      w3=0;
	    }
	  else if(meani<3+2*N)//left cortex
	    {
	      w1=5;//*5;
	      w2=4;//*4;
	      w3=3;//*3;
	    }
	  else if(meani>n-2*N-4)//right cortex
	    {
	      w1=3;//*3;
	      w2=4;//*4;
	      w3=5;//*5;
	    }
	  else if(meani<5+3*N)//left border
	    {
	      w1=4;//*4;
	      w2=3;//*3;
	      w3=2;//*2;
	    }
	  else if(meani>n-3*N-6)//right border
	    {
	      w1=2;//*2;
	      w2=3;//*3;
	      w3=4;//*4;
	    }
	  else if(meani<7+4*N)//left vasc
	    {
	      w1=3;//*3;
	      w2=2;//*2;
	      w3=0;
	    }
	  else if(meani>n-4*N-8)//right vasc
	    {
	      w1=0;
	      w2=2;//*2;
	      w3=3;//*3;
	    }
	  

	  count=0;
	  for(j=CellMinJ[q];j<=CellMaxJ[q];j++)//multiple nbs along length direction cell possible
	    {
	      //left neighbouring cell
	      i=max(0,CellMinI[q]-3);
	      qq=Cell[i][j];
	      if(qq!=-1)
		{
		  Rgrowavg[q]+=w1*Rgrow[qq];
		  count+=w1;
		}
	      //cell itself
	      Rgrowavg[q]+=w2*Rgrow[q];
	      count+=w2;
	      //right neighbouring cell
	      i=min(n-1,CellMaxI[q]+3);
	      qq=Cell[i][j];
	      if(qq!=-1)
		{
		  Rgrowavg[q]+=w3*Rgrow[qq];
		  count+=w3;
		}
	    }
	  Rgrowavg[q]/=(double)count;
	}
      //reset Rgrow to Rgrowavg
      for(q=0;q<actcells;q++)
	Rgrow[q]=Rgrowavg[q];
    }

  double distfact=1;
    
  for(q=0;q<actcells;q++)
    {
      if(JustChecked[q]==0)
	{
	  H=CellHeight[q];

#ifdef PLTDEPZONATION
	  if(Plts[q]>40 || CellMaxJ[q]<5*M1+5*2)
#else
	  if(CellMinJ[q]<49 || CellMaxJ[q]<5*M1+5*2)
#endif
	    {
	      CellZonationState[q]=0;
	      JustChecked[q]=1;
	    }
#ifdef PLTDEPZONATION
	  else if(Plts[q]>15)
#else
	  else if(CellMinJ[q]<500)//<210)  
#endif
	    {
	      CellZonationState[q]=30;	  
	      JustChecked[q]=1;

	      if(CellMinJ[q]>=yLRC1 && 
		 (Tct[CellMinI[q]][CellMinJ[q]]>4 && Tct[CellMinI[q]][CellMinJ[q]]<12))
		{
		  if((Tct[CellMinI[q]][CellMinJ[q]]>2 && H<=Hdiv) ||
		     (Tct[CellMinI[q]][CellMinJ[q]]<=2 && H<=Hdivlrc))
		    {                   	       
		      double dist=CellMinJ[q]-yLRCstraight;
		      double max=1.5;
		      double min=0.75;
		      double maxdist=yMZEZ-yLRstraight;
		      double ksat=0.5*maxdist;
		      distfac=(max-min)*(ksat*ksat/(ksat*ksat+dist*dist))+min;
		      

		      tgrowth=1./(distfac*Rgrow[q]*CellHeight[q]);
		      
		      if(time>=TimePrevGrowth[q]+tgrowth)
			{
			  for(i=CellMinI[q]-1;i<=CellMaxI[q]+1;i++)
			    for(j=CellMinJ[q]-1;j<=CellMaxJ[q]+1;j++)
			      GrowthRate[i][j]+=1;
			
			  //printf("cytoplasmic growth\n");
			  TimePrevGrowth[q]=time;
			  GrowCell(time,q,0);
			  q=-1; 
			} 		   
		    }
		  else
		    {
		      for(i=CellMinI[q]-1;i<=CellMaxI[q]+1;i++)
			for(j=CellMinJ[q]-1;j<=CellMaxJ[q]+1;j++)
			  DivRate[i][j]+=1;

		      //printf("division\n");
		      DivideCell(time,q);
		      q=-1;
		    }
		}
	    }
	  else//EZ or  DZ
	    {
	      JustChecked[q]=1;

	      //differentiation starts in EZ, proceeds in DZ
#ifdef ARFDEPRATES  	      
	      if((int)1000*Diff[q]==0 && ARF[q]>2)//only at start of diff
		Diff[q]+=0.001;
	      else if((int)(1000*Diff[q])<5 && ARF[q]>2)//first phase of diff
		Diff[q]+=tstep*speedup2*(diffrate-decaydiffrate*Diff[q]);
	      else if((int)(1000*Diff[q])>5)//only once differentiation is started
		Diff[q]+=tstep*speedup2*(diffrate-decaydiffrate*Diff[q]);
#else
	      if((int)1000*Diff[q]==0)//only at start of diff
		Diff[q]+=0.001;
	       else
		Diff[q]+=tstep*speedup2*(diffrate-decaydiffrate*Diff[q]);
#endif

	      if(Diff[q]<85)
		{
		  CellZonationState[q]=60;

		  if(CellMinJ[q]>=yLRC1)//if(CellMinJ[q]>=yR && Tct[CellMinI[q]][CellMinJ[q]]>4)//if(CellMinJ[q]>=yLRC1)
		    {
		      if(H<Hmax)
			{
			  tgrowth=1./(Rgrow[q]*CellHeight[q]);
			  
			  if(time>=TimePrevGrowth[q]+tgrowth)
			    {
			      
			      for(i=CellMinI[q]-1;i<=CellMaxI[q]+1;i++)
				for(j=CellMinJ[q]-1;j<=CellMaxJ[q]+1;j++)
				  GrowthRate[i][j]+=1;

			      //printf("cell expansion\n");
			      TimePrevGrowth[q]=time;
			      GrowCell(time,q,1);
			      q=-1;
			    }
			}
		    }
		}
	      else
		CellZonationState[q]=100;            
	    }
	}
    }
}


void GrowCell(int time,int q,int growthtype)
{
  int i,j;
  int ii;
  int jstart;
  int jstop;
  double oldh,newh;
  double oldv,newv;
  double volratTF,volratnonTF;
   
  //shift all those cells lying above cell q, 
  //+ its above lying wall + its top membrane 
  //one row upward
  //do this for cell and directly nb wall
  //istart=CellMinI[q]-1;
  //istop=CellMaxI[q]+1;

  //determine nr of cell file
  int cellfilenr=1000;
  j=(int)(0.5*(CellMinJ[q]+CellMaxJ[q]));
  //j=CellCentroid[q][1];
  for(i=0;i<(15-1);i++)
    {
      if(CellMinI[q]>istart[j][i] && CellMaxI[q]<istart[j][i+1])
      //if(CellCentroid[q][0]>istart[j][i] && CellCentroid[q][0]<istart[j][i+1])
	{
	  cellfilenr=i;
	  i=100;
	}
    }
  if(cellfilenr==1000)
    printf("no appropriate cellfilenr found, cell nr is %i cell centre %i %i celltype is %i with yR %i yLRC1 %i!\n",q,(int)(0.5*(CellMinI[q]+CellMinJ[q])),(int)(0.5*(CellMinJ[q]+CellMaxJ[q])),Tct[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][(int)(0.5*(CellMinJ[q]+CellMaxJ[q]))],yR,yLRC1);
  /*
  int cellfilenr;
  j=CellMinJ[q];
  for(i=0;i<(15-1);i++)
    {
      if(CellMinI[q]>istart[j][i] && CellMinI[q]<istart[j][i+1])
	{
	  cellfilenr=i;
	  i=100;
	}
    }
  */
  int istartsource;
  int istopsource;
  int lengthsource;
  int istartdest;
  int istopdest;
  int lengthdest;
  double scale;
  /*
  int qq;
  for(qq=0;qq<actcells;qq++)
    {
      if(CellMinJ[qq]>yLRC1)
	{
	  j=CellMinJ[qq];
	  //source row
	  istartsource=istart[j][cellfilenr]+1;//left membrane
	  istopsource=istart[j][cellfilenr+1]-1;//right membrane
	  lengthsource=istopsource-istartsource;//horizontal length
	  //destination row
	  istartdest=istart[j+1][cellfilenr]+1;//left membrane
	  istopdest=istart[j+1][cellfilenr+1]-1;//right membrane
	  lengthdest=istopdest-istartdest;//horizontal length
	  //scaling
	  scale=(double)lengthdest/(double)lengthsource;
	  
	  printf("%i %i %i %i, %i %i %i %i, %f\n",j,istartsource,istopsource,lengthsource,j+1,istartdest,istopdest,lengthdest,scale);
	}
    }
  exit(1);
  */

  //shift all upward but considering curvedness using istart array
  jstart=CellMaxJ[q]-1;//one row under top membrane
  jstop=m-2;
  for(j=jstop;j>=jstart;j--)//j>=jstart so including topmembrane cell q
    for(i=istart[j][cellfilenr];i<=istart[j][cellfilenr+1];i++) 
      //perhaps necessary that for left side you do i=istart i<istart (only shift leftwall with you)
      //while for right side you do i=istart+1 i<=istart (only shift right wall with you)
      //and do something special for middle most cell wall
      {

	if(i==istart[j][cellfilenr])//left wall
	  ii=istart[j+1][cellfilenr];
	else if(i==istart[j][cellfilenr]+1)//left membrane
	  ii=istart[j+1][cellfilenr]+1;
	else if(i==istart[j][cellfilenr+1]-1)//right membrane
	  ii=istart[j+1][cellfilenr+1]-1;
	else if(i==istart[j][cellfilenr+1])//right wall
	  ii=istart[j+1][cellfilenr+1];
	else//in between!
	  {
	    double ls=(istart[j][cellfilenr+1]-1)-(istart[j][cellfilenr]+1);
	    double ld=(istart[j+1][cellfilenr+1]-1)-(istart[j+1][cellfilenr]+1);
	    double alpha=ld/ls;
	    ii=(istart[j+1][cellfilenr]+1)+alpha*(i-(istart[j][cellfilenr]+1));
	  }
	//now the real action:
	//shift cell, membrane, wall locations
	Tc[ii][j+1]=Tc[i][j];
	Tct[ii][j+1]=Tct[i][j];//!!!
	Tmt[ii][j+1]=Tmt[i][j];//!!!
	Cell[ii][j+1]=Cell[i][j];
	//shift Pin/Lax3/Lax2/Aux1
	PinPrePat[ii][j+1]=PinPrePat[i][j];
	Lax3PrePat[ii][j+1]=Lax3PrePat[i][j];
	Lax2PrePat[ii][j+1]=Lax2PrePat[i][j];
	Aux1PrePat[ii][j+1]=Aux1PrePat[i][j];
	//shift auxin levels
	if(j>CellMaxJ[q]-1)
	  Caux1[ii][j+1]=Caux1[i][j];
      }

  //implicit consideration of cytoplasmic or vacuolar growth
  //does not work when it is a substance undergoing diffusion
  //in that case, during vacuolar growth, the concentration
  //in the cytoplasm should stay the same, but so does the
  //amount of cytoplasm and hence the amount available for
  //diffusion, however by not explicitly considering cytoplasm
  //and vacuoles it appaers that concentration in cytoplasm
  //stays the same but volume increases and hence available
  //amount increases
  //auxin and PLTs diffuse
  //now PLTs do not dilute upon vacuolar growth, auxin does

  //dilute gene expression levels 
  oldh=CellHeight[q];
  //non-TF
  //grow from h=4 to h=9 so +5 but than add walls so -2, so effectively 4+3=7 so +3 so 3/5=0.6
  newh=oldh+0.6;//oldh+1;
  oldv=oldh*CellWidth[q];
  newv=newh*CellWidth[q];
  volratnonTF=(double)oldv/(double)newv;
  //TF
  //assume large part is not in cytoplasm and hence not diluted
  newh=oldh+0.6;//+0.15;//oldh+1;
  oldv=oldh*CellWidth[q];
  newv=newh*CellWidth[q];
  double fractcyto=0.5;
  volratTF=(fractcyto*((double)oldv/(double)newv)+(1-fractcyto));
  if(growthtype==0)//cytoplasmic
    {
      //TF
      ARF[q]*=volratTF;
      GG[q]*=volratTF;
      AA[q]*=volratTF;
      BB[q]*=volratTF;
      CC[q]*=volratTF;
      DD[q]*=volratTF;
      Plt[q]*=volratTF;
      Plts[q]*=volratTF;
      //Diff[q]*=volratTF;
     

      //non-TF
#ifdef PINREGULATED
      Pin[q]*=volratnonTF;
#endif
#ifdef YUC3GH33REGULATED
      Yuc3[q]*=volratnonTF;
      Gh33[q]*=volratnonTF;
#endif
#ifdef LAX3REGULATED
      Lax3[q]*=volratnonTF;
#endif
#ifdef LAX2REGULATED
      Lax2[q]*=volratnonTF;
#endif
#ifdef AUX1REGULATED
      Aux1[q]*=volratnonTF;
#endif
    }
  //else//vacuolar, no dilution of cytoplasmic conc
   
  
  TimePrevGrowth[q]=time;
  //in case of growth: do not renumber the cells
  //in this case lower left corner of cells may shift
  //so our method of mapping old to new cell ids 
  //does not work, as it assumes that lower left
  //corners of cells do not change, which is only
  //true during cell division (apart from new cell)
  //and cell culling (apart from removed cells)!!!!!
  //instead we just maintain old cell numbering
  //but make sure cells grow and cells above it shift
  //the recomputing off cellcorners and sizes does
  //work then
  FindCellCorners();
  FindCellSizes();
  FindCellCentroid();
  CullOverflowCells(time); 
}


void DivideCell(int time,int q)
{
  int i,j;
  int divtime;
  int jstart;
  int jstop;
  int jwall;
  int lowl,highl;
  double meani,meanj;
  int oldid,newid,aboveid,oldmini,oldminj;
  int oldv,newv1,newv2;
  double volrat;

  /*
  int cellfilenr;
  int qq;
  for(qq=0;qq<actcells;qq++)
    {
      if(CellMinJ[qq]>yLRC1)//in straight part root
	{ 	  
	  //determine cellfilenr
	  j=CellMinJ[qq];
	  for(i=0;i<(15-1);i++)
	    {
	      if(CellMinI[q]>istart[j][i] && CellMinI[q]<istart[j][i+1])
		{
		  cellfilenr=i;
		  i=100;
		}
	    }
	  
	  //comparisons
	  if((CellMinI[q]-1)!=istart[j][cellfilenr])
	    printf("old and new start unequal!\n");
	  if((CellMaxI[q]+1)!=istart[j][cellfilenr+1])
	    printf("old and new stop unequal!\n");
	}
    }
  exit(1);
  */


 
  //cell q is up for a division
  int cellfilenr=1000;
  j=(int)(0.5*(CellMinJ[q]+CellMaxJ[q]));
  //j=CellCentroid[q][[1];
  for(i=0;i<(15-1);i++)
    {
      if(CellMinI[q]>istart[j][i] && CellMaxI[q]<istart[j][i+1])
      //if(CellCentroid[q][0]>istart[j][i] && CellCentroid[q][0]<istart[j][i+1])
	{
	  cellfilenr=i;
	  i=100;
	}
    }
  if(cellfilenr==1000)
     printf("no appropriate cellfilenr found, cell nr is %i cell centre %i %i celltype is %i with yR %i yLRC1 %i!\n",q,(int)(0.5*(CellMinI[q]+CellMinJ[q])),(int)(0.5*(CellMinJ[q]+CellMaxJ[q])),Tct[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][(int)(0.5*(CellMinJ[q]+CellMaxJ[q]))],yR,yLRC1);
    
  /*
  for(i=0;i<(15-1);i++)
    for(j=0;j<m;j++)
      {
	//printf("at %i %i start is %i\n",i,j,istart[j][i]);
	if(istart[j][i]<0 || istart[j][i]>1000)
	  printf("something wrong!\n");
      }
  */

  //printf("cellfilenr %i \n",cellfilenr);
  jwall=CellHeight[q]/2;
  lowl=jwall-CellMinJ[q];
  highl=CellMaxJ[q]-jwall+1;
  oldv=CellWidth[q]*CellHeight[q];
  newv1=CellWidth[q]*lowl;
  newv2=CellWidth[q]*highl;
  volrat=(double)oldv/(double)(newv1+newv2);


  j=(CellMinJ[q]+jwall-1);//top membrane lower daughter cell
  for(i=(istart[j][cellfilenr]+1);i<istart[j][cellfilenr+1];i++)
    {
      Tc[i][j]=2;//put to membrane
      Tmt[i][j]=1;//put to top membrane

      //dit gaat niet kloppen voor gecurvde cellen!
      //istart-istop van top en bottom membranes
      //en nieuwe midden membranes kunnen 
      //verticaal geshift zijn!
      //gokken op middenwaarde i?
      //of cell en zone specifieke pin patterns maken
      PinPrePat[i][j]=PinPrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMaxJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMaxJ[q]];
      Lax2PrePat[i][j]=Lax2PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMaxJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMaxJ[q]];
    }
  j=(CellMinJ[q]+jwall);//wall layer
  for(i=(istart[j][cellfilenr]+1);i<istart[j][cellfilenr+1];i++)
    {
      Tc[i][j]=0;//wall
      Tct[i][j]=20;//wall
      Tmt[i][j]=0;//wall
    }
  j=(CellMinJ[q]+jwall+1);//bottom membrane top daughter cell
  for(i=(istart[j][cellfilenr]+1);i<istart[j][cellfilenr+1];i++)
    {
      Tc[i][j]=2;//put to membrane
      Tmt[i][j]=1;//put to top membrane 

      //dit gaat niet kloppen voor gecurvde cellen!
      //istart-istop van top en bottom membranes
      //en nieuwe midden membranes kunnen 
      //verticaal geshift zijn!
      //gokken op middenwaarde i?
      PinPrePat[i][j]=PinPrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMinJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMinJ[q]];
      Lax2PrePat[i][j]=Lax2PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMinJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[(int)(0.5*(CellMinI[q]+CellMaxI[q]))][CellMinJ[q]]; 
    }

#ifdef YYY
  for(i=istart;i<=istop;i++)
    {
      //first layer membrane: top membrane lower daughter cell
      j=CellMinJ[q]+jwall-1;
      Tc[i][j]=2;//put to membrane
      Tmt[i][j]=1;//put to top membrane 
      //copy its protein pattern from top membrane mother cell
      PinPrePat[i][j]=PinPrePat[i][CellMaxJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[i][CellMaxJ[q]];
      Lax2PrePat[i][j]=Lax2PrePat[i][CellMaxJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[i][CellMaxJ[q]];

      //wall layer
      j=CellMinJ[q]+jwall;
      Tc[i][j]=0;//put to wall
      Tct[i][j]=20;//put to wall
      Tmt[i][j]=0;//put to wall
      
      //second layer membrane: bottom membrane top daughter cell
      j=CellMinJ[q]+jwall+1;
      Tc[i][j]=2;//put to membrane
      Tmt[i][j]=2;//put to bottom membrane
      PinPrePat[i][j]=PinPrePat[i][CellMinJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[i][CellMinJ[q]];
      Lax2PrePat[i][j]=Lax2PrePat[i][CellMinJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[i][CellMinJ[q]]; 
    }
#endif
 
  //Make sure to store old cell identities, locations,
  //and corresponding properties before doing division
  //clean the arrays
  int oldactcells=actcells;
  StoreOldSituation(oldactcells);
  //old identity dividing cell + location
  oldid=q;
  oldmini=CellMinI[q];
  oldminj=CellMinJ[q];
  int oldcentrei=CellCentroid[q][0];
  int oldcentrej=CellCentroid[q][1];

  //renumber cells after division
  NumberCells();
  FindCellCorners();
  FindCellSizes();
  //map old identities cells to their new ones
  MapOldToNewSituation(oldactcells);
  //find new identity dividing cell
  newid=Cell[oldmini][oldminj];
  //find identity top daughter cell
  //below can not work anymore in curved cells
  //you may end up in cell file before or after
  aboveid=Cell[CellMinI[newid]][CellMaxJ[newid]+3];
  //if(i<....)//on left side of root
  //aboveid=Cell[oldcentrei-1][oldcentrej+2];
  //else//on right side of root
  //aboveid=Cell[oldcentrei+1][oldcentrej+2];
  //make sure oldid maps to newid and aboveid
  TimePrevGrowth[aboveid]=TimePrevGrowth[newid];
  ARF[aboveid]=ARF[newid];
  AA[aboveid]=AA[newid];
  BB[aboveid]=BB[newid];
  CC[aboveid]=CC[newid];
  DD[aboveid]=DD[newid];
  Plt[aboveid]=Plt[newid];
  Lax3[aboveid]=Lax3[newid];
  Plts[aboveid]=Plts[newid];
  Pin[aboveid]=Pin[newid];
  Yuc3[aboveid]=Yuc3[newid];
  Gh33[aboveid]=Gh33[newid];
  Lax2[aboveid]=Lax2[newid];
  Aux1[aboveid]=Aux1[newid];
  MeanCells[aboveid]=MeanCells[newid];
  Rgrow[aboveid]=Rgrow[newid];
  Rgrowavg[aboveid]=Rgrowavg[newid];
  JustChecked[aboveid]=JustChecked[newid];//!!
  CellZonationState[aboveid]=CellZonationState[newid];
  Diff[aboveid]=Diff[newid];
 
  q=-1;
}


void CullOverflowCells(int time)
{
  //due to the growth, cells get pushed over the edge
  //these cells need to be removed as soon as their
  //above cell wall drops over the edge to make sure
  //that only entire cells are part of the simulation
  //this automatically ensures that cell numbers do
  //not increase indefinetely

  int i,j,q;
  int ii,jj,iii,jjj;
  int counter;

  //scan line below topline
  //if still ok, it contains only external (3) or wall (0)
  //if culling is needed, it contains cytoplasm (1) or membrane (2) 
  //we do line below topline, as we need topline to create artificial
  //membrane/cell part for correct influx/efflux relation between
  //root and shoot


  int culling[totcells];
  for(q=0;q<totcells;q++)
    culling[q]=0;

  //first determine which cells need to be culled
  //m-1 is last row
  //m-2 is second last row
  //so rather than checking whether there is a wall in last
  //row we check whether there is a cell in the second last row
  j=m-2;
  for(i=0;i<n;i++)
    {
      if(Tc[i][j]==1 || Tc[i][j]==2)//culling needed!
	{
	  //which cell is sitting here?
	  q=Cell[i][j];
	  culling[q]=1;
	}
    }
  //determine whether there is one or more cells to be culled
  counter=0;
  for(q=0;q<totcells;q++)
    {
      if(culling[q]==1)
	{
	  counter++;
	  //printf("time %i cell %i needs culling\n",time,q);
	}
    }
  //do the culling if at least one cell needs to be culled
  if(counter>0)
    {
      //now do the GRID based adjustments:
      //find where it sits in the field and remove it
 
      for(q=0;q<totcells;q++)
	{
	  if(culling[q]==1)
	    {
	      //removing cell itself
	      for(ii=CellMinI[q];ii<=CellMaxI[q];ii++)//for(ii=1;ii<n-1;ii++)
		for(jj=CellMinJ[q];jj<=CellMaxJ[q];jj++)//for(jj=1;jj<m-1;jj++)
		  {    
		    //put all to non-tissue status
		    Tc[ii][jj]=3;
		    Tct[ii][jj]=0;
		    Tmt[ii][jj]=0;
		    PinPrePat[ii][jj]=0;
		    //more to come
		    Cell[ii][jj]=-1;
		    Caux1[ii][jj]=-10;//0;		      
		    
		  }
	      //removing walls if possible
	      //wall above can go
	      jjj=CellMaxJ[q]+1;
	      for(iii=CellMinI[q]-1;iii<=CellMaxI[q]+1;iii++)
		{
		  if(Tc[iii][jjj]==0)//cell wall
		    {
		      Tc[iii][jjj]=3;
		      Tct[iii][jjj]=0;
		      Tmt[iii][jjj]=0;
		      Cell[iii][jjj]=-1;
		      Caux1[iii][jjj]=-10;//0;
		    }
		}
	      //wall left can go if no other cell bordering it
	      iii=CellMinI[q]-1;
	      for(jjj=CellMinJ[q];jjj<=CellMaxJ[q];jjj++)
		{
		  if(Tc[iii][jjj]==0 && Tc[iii-1][j]==3)//cell wall
		    {
		      Tc[iii][jjj]=3;
		      Tct[iii][jjj]=0;
		      Tmt[iii][jjj]=0;
		      Cell[iii][jjj]=-1;
		      Caux1[iii][jjj]=-10;//0;
		    }
		}
	      //wall right can go if no other cell bordering it
	      iii=CellMinI[q]+1;
	      for(jjj=CellMinJ[q];jjj<=CellMaxJ[q];jjj++)
		{
		  if(Tc[iii][jjj]==0 && Tc[iii+1][j]==3)//cell wall
		    {
		      Tc[iii][jjj]=3;
		      Tct[iii][jjj]=0;
		      Tmt[iii][jjj]=0;
		      Cell[iii][jjj]=-1;
		      Caux1[iii][jjj]=-10;//0;
		    }
		}
	      //wall below can not go: cell below it
	    }//if found cell to be culled
	}//for loop over cells

      //next do the CELL based readjustments:
      int oldactcells=actcells;
      StoreOldSituation(oldactcells);
      NumberCells();
      FindCellCorners();
      FindCellSizes();
      FindCellCentroid();
      MapOldToNewSituation(oldactcells);
    }//if(counter>0)
}

void StoreOldSituation(int oldactcells)
{
  int i,k;

  //Make sure to store old cell identities, locations,
  //and corresponding properties before doing division
  //clean the arrays
  for(i=0;i<totcells;i++)
    {
      OldSit[i][0]=-1;
      OldSit[i][1]=-1;
      OldSit[i][2]=-1;
      
      OldTimePrevGrowth[i]=-1;
      OldARF[i]=-1;
      OldAA[i]=-1;
      OldBB[i]=-1;
      OldCC[i]=-1;
      OldDD[i]=-1;
      OldPlt[i]=-1;
      OldLax3[i]=-1;
      OldPlts[i]=-1;
      OldPltsexpr[i]=-1;
      OldPin[i]=-1;
      OldYuc3[i]=-1;
      OldGh33[i]=-1;
      OldLax2[i]=-1;
      OldAux1[i]=-1;
      OldMeanCells[i]=-1;
      OldRgrow[i]=-1;
      OldRgrowavg[i]=-1;
      OldCellZonationState[i]=-1;
      OldDiff[i]=-1;
      OldJustChecked[i]=-1;
    }
  //fill them
  for(i=0;i<oldactcells;i++)
    {
      OldSit[i][0]=i;//old cell nr
      OldSit[i][1]=CellMinI[i];//min i value
      OldSit[i][2]=CellMinJ[i];//min j value
      
      OldTimePrevGrowth[i]=TimePrevGrowth[i];
      OldARF[i]=ARF[i];
      OldAA[i]=AA[i];
      OldBB[i]=BB[i];
      OldCC[i]=CC[i];
      OldDD[i]=DD[i];
      OldPlt[i]=Plt[i];
      OldLax3[i]=Lax3[i];
      OldPlts[i]=Plts[i];
      OldPltsexpr[i]=Pltsexpr[i];
      OldPin[i]=Pin[i];
      OldYuc3[i]=Yuc3[i];
      OldGh33[i]=Gh33[i];
      OldLax2[i]=Lax2[i];
      OldAux1[i]=Aux1[i];
      OldMeanCells[i]=MeanCells[i];
      OldRgrow[i]=Rgrow[i];
      OldRgrowavg[i]=Rgrowavg[i];
      OldCellZonationState[i]=CellZonationState[i];
      OldDiff[i]=Diff[i];
      OldJustChecked[i]=JustChecked[i];
    } 
}


void MapOldToNewSituation(int oldactcells)
{
  int i,j,k;

  //map old identities cells to their new ones
  for(i=0;i<actcells;i++)//new cells
    for(j=0;j<oldactcells;j++)//old cells
      {
	if(OldSit[j][1]==CellMinI[i] && OldSit[j][2]==CellMinJ[i])
	  MapCellNrs[i]=j;//new cell i was old cell j
      }

   for(i=0;i<actcells;i++)
     {
       TimePrevGrowth[i]=OldTimePrevGrowth[MapCellNrs[i]];
       ARF[i]=OldARF[MapCellNrs[i]];
       AA[i]=OldAA[MapCellNrs[i]];
       BB[i]=OldBB[MapCellNrs[i]];
       CC[i]=OldCC[MapCellNrs[i]];
       DD[i]=OldDD[MapCellNrs[i]];
       Plt[i]=OldPlt[MapCellNrs[i]];
       Lax3[i]=OldLax3[MapCellNrs[i]];
       Plts[i]=OldPlts[MapCellNrs[i]];
       Pltsexpr[i]=OldPltsexpr[MapCellNrs[i]];
       Pin[i]=OldPin[MapCellNrs[i]];
       Yuc3[i]=OldYuc3[MapCellNrs[i]];
       Gh33[i]=OldGh33[MapCellNrs[i]];
       Lax2[i]=OldLax2[MapCellNrs[i]];
       Aux1[i]=OldAux1[MapCellNrs[i]];
       MeanCells[i]=OldMeanCells[MapCellNrs[i]];
       Rgrow[i]=OldRgrow[MapCellNrs[i]];
       Rgrowavg[i]=OldRgrowavg[MapCellNrs[i]];
       CellZonationState[i]=OldCellZonationState[MapCellNrs[i]];
       Diff[i]=OldDiff[MapCellNrs[i]];
       JustChecked[i]=OldJustChecked[MapCellNrs[i]];
     }
}

