#include "Header.hh"


//#define RANDOMGROWTH
//#define DISCRETEEXPONENTIALGROWTH
//#define DISCRETELINEARGROWTH


//#define RANDOMGROWTH
//#define RANDOMEXPANSION
//#define LINEARGROWTH
//#define LINEAREXPANSION
#define EXPONENTIALGROWTH
#define EXPONENTIALEXPANSION

void DetermineOZ(int time)
{
  int i,j,q;
  int nrcellsOZup=5;
  int nrcellsOZdown=7;
  int nrcellsOZuplrc=5;
  int nrcellsOZdownlrc=3;
  int jMZEZboundary;
  int jMZEZboundarylrc;
  int jmaxLRC;
  int cellid;
  int cellcount;
  
  for(q=0;q<totcells;q++)
    CellsInOZ[q]=0;
  

  //issue: what to do with the LRC?
  //LRC may have different position of boundaries due to different cell sizes?
  //depending on whether or not lrc apoptosis is normal or aberrant
  //normal apoptosis: no EZ in LRC, but MZ may reach up bit higher or lower
  //SMB mutant: also EZ in LRC, and  boundary position may differ
  //FEZ mutant: no EZ in LRC, MZ much lower


  //determine MZ EZ boundary and/or upper boundary LRC
#ifndef RESTART
  if(time==0)//tov positie, zones not yet known
    {
      jMZEZboundary=yLRC1;//boundary MZ EZ
      jMZEZboundarylrc=yLRC1;
    }
  else//tov zones
#endif
    {
      //find j value MZ EZ boundary
      //note that because of position based zonation
      //all cells grow and divide synchronously
      //so currently this j value is the same
      //for all cells
      i=xm-2;//make sure not to be on wall, inside main root 
      for(j=m-2;j>=yLRCstraight;j--)//!
	{
	  if(Tc[i][j]==0)//wall
	    {
	      
	      if(CellZonationState[Cell[i][j+1]]==60 &&
		 CellZonationState[Cell[i][j-1]]==30)
		{
		  jMZEZboundary=j;
		  break;
		}
	    }
	}
#ifndef SMBMUTANT
#ifdef FEZMUTANT
      //assume for now that in fez mutant lrc is so short that it does
      //not reach up to oscillation zone and hence does not contribute
      //any cells to it
      //no need to compute the boundary
#else
      //normal WT
      //normal lrc, so no EZ in lrc, upper boundary MZ = upper boundary lrc
      //for now we assume that left and right are symmetric
      i=disttolrc+1;//make sure not to be on wall, inside lrc
      for(j=m-2;j>=yLRCstraight;j--)//!
	{
	  if(Tc[i][j]==0)//wall
	    {
	      jMZEZboundarylrc=j;
	      break;
	    }
	} 
#endif
#else
      //smb mutant, so EZ in lrc but with potentially different boundary location
      //for now we assume that left and right are symmetric
      i=disttolrc+1;//make sure not to be on wall, inside lrc
      for(j=m-2;j>=yLRCstraight;j--)//!
	{
	  if(Tc[i][j]==0)//wall
	    {
	      
	      if(CellZonationState[Cell[i][j+1]]==60 &&
		 CellZonationState[Cell[i][j-1]]==30)
		{
		  jMZEZboundarylrc=j;
		  break;
		}
	    }
	}
#endif
    }
  
  //now the real work: determine cells in OZ

  //for the main root
  //not efficient: every i value done, instead of per cell file
  //still, may be necessary if you also want to define OZ on 
  //grid level, for example for transporters
  //upward
  
  
  for(i=disttoepi;i<n-1-disttoepi;i++)//only main root, not lrc
    {
      cellcount=0;//no cell yet in this line
      j=jMZEZboundary;//startposition
      while(cellcount<nrcellsOZup)
	{
	  
	  while(Cell[i][j]==-1 && j<m-1)//no cell yet
	    j++;
	  cellid=Cell[i][j];//found new cell
	  CellsInOZ[cellid]=1;//mark as part of OZ
	  cellcount++;//count it
	  while(Cell[i][j]==cellid && j<m-1)//same cell
	    j++;    
	}
      cellid = 0;
    }
  //downward
  
	
  for(i=disttoepi;i<n-1-disttoepi;i++)//only main root, not lrc
    {	
		
      j=jMZEZboundary;//startposition
      cellcount=0;//no cell yet in this line  
      while(cellcount<nrcellsOZdown)
	{
	  
	  while(Cell[i][j]==-1 && j>yLRCstraight)//!//j>1)//no cell yet
	    j--;
	  cellid=Cell[i][j];//found new cell
	  CellsInOZ[cellid]=1;//mark as part of OZ
	  cellcount++;//count it
 	  while(Cell[i][j]==cellid && j>yLRCstraight)//!//j>1)//same cell
	    j--;    
	}
      cellid = 0;
    }

  //for the lateral root cap
#ifdef FEZMUTANT
  //assume for now that in fez mutant lrc is so short that it does
  //not reach up to oscillation zone and hence does not contribute
  //any cells to it
  //so nothing to do
#else
  //both in WT and SMB mutant cells below boundary contribute to OZ
  //downward
  
  i=disttolrc+1;//only inside left lrc
  {
    cellcount=0;//no cell yet in this line
    j=jMZEZboundarylrc;//startposition
    while(cellcount<nrcellsOZdownlrc)
      {
	
	while(Cell[i][j]==-1 && j>yLRCstraight)//!//j>1)//no cell yet
	  j--;
	cellid=Cell[i][j];//found new cell
	CellsInOZ[cellid]=1;//mark as part of OZ
	cellcount++;//count it
	while(Cell[i][j]==cellid && j>yLRCstraight)//!//j>1)//same cell
	  j--;    
      }
      cellid = 0;
  }
  
  
  i=n-1-(disttolrc+1);//only inside right lrc
  {
    cellcount=0;//no cell yet in this line
    j=jMZEZboundarylrc;//startposition
    while(cellcount<nrcellsOZdownlrc)
      {
	
	while(Cell[i][j]==-1 && j>yLRCstraight)//!//j>1)//no cell yet
	  j--;
	cellid=Cell[i][j];//found new cell
	CellsInOZ[cellid]=1;//mark as part of OZ
	cellcount++;//count it
	while(Cell[i][j]==cellid && j>yLRCstraight)//!//j>1)//same cell
	  j--;    
      }
      cellid = 0;     
  }
#ifdef SMBMUTANT
  //only in SMB mutant also EZ in lrc and cells upward
  //of MZ EZ boundary contribute to OZ
  //upward
  i=disttolrc+1;//only inside left lrc
  {
    cellcount=0;//no cell yet in this line
    j=jMZEZboundarylrc;//startposition
    while(cellcount<nrcellsOZuplrc)
      {
	
	while(Cell[i][j]==-1 && j<m-1)//no cell yet
	  j++;
	cellid=Cell[i][j];//found new cell
	CellsInOZ[cellid]=1;//mark as part of OZ
	cellcount++;//count it
	while(Cell[i][j]==cellid && j<m-1)//same cell
	  j++;    
      }
      cellid = 0;
  }
  i=n-1-(disttolrc+1);//only inside right lrc
  {
    cellcount=0;//no cell yet in this line
    j=jMZEZboundarylrc;//startposition
    while(cellcount<nrcellsOZuplrc)
      {
	
	while(Cell[i][j]==-1 && j<m-1)//no cell yet
	  j++;
	cellid=Cell[i][j];//found new cell
	CellsInOZ[cellid]=1;//mark as part of OZ
	cellcount++;//count it
	while(Cell[i][j]==cellid && j<m-1)//same cell
	  j++;    
      }  
      cellid = 0;   
  }
#endif
#endif
}


void Growth(int time)
{
  int i,j,q;
  int H;
  double P;
  int meani,mini,maxi,meanj;
  int tgrowth;
  static int first_time=0;


  //Rdiv: intrinsic cellular growth & division rate
  //Relong: intrinsic cellular elongation rate
  //Rgrow: actual current growth rate of cell based on intrinsic
  //rates, and where it is (division or elongation zone), 
  //auxin/nearness QC etc



  //initial computation of what intrinsic rates should be
  //as cells divide and new daughters arise computations 
  //are done in routine DivideCell
  //#ifndef RESTART
#ifndef RANDOMGROWTH
  double divtime;
  double elongtime;
  double sumdiv;
  double divrate;
  double sumelong;
  double elongrate;
  double steptime;
  double R1;
  if(first_time==0)
    {
      for(q=0;q<actcells;q++)
	{
	 
	  divtime=avgdivtime;
#ifdef EXPONENTIALGROWTH
	  sumdiv=0;
	  for(i=HMZ;i<=2*HMZ;i++)
	    sumdiv+=(1./((double)i));
	  divrate=sumdiv/divtime;
	  Rdiv[q]=divrate;
#endif
#ifdef LINEARGROWTH
	  steptime=divtime/HMZ;
	  divrate=1./steptime;
	  Rdiv[q]=divrate;
#endif	  
	  elongtime=avgelongtime;
#ifdef EXPONENTIALEXPANSION
	  sumelong=0;
	  for(i=((int)2*HMZ);i<=Hmax;i++)//for(i=((int)1.5*HMZ);i<=Hmax;i++)
	    sumelong+=(1./((double)i));
	  elongrate=sumelong/elongtime;
	  Relong[q]=elongrate;
#endif
#ifdef LINEAREXPANSION
	  steptime=elongtime/(Hmax-((int)(2*HMZ)));//steptime=elongtime/(Hmax-((int)(1.5*HMZ)));
	  elongrate=1./steptime;
	  Relong[q]=elongrate;
#endif	  
	}
      first_time=1;
    }
#endif
  //#endif
  
  for(i=0;i<totcells;i++)
    JustChecked[i]=0;

 
  double rdivaux,relong;
  //cell based Rgrow
  for(q=0;q<actcells;q++)
    {
      if(CellMaxJ[q]<yR)//SCN: ignore growth
	Rgrow[q]=0.0000001;
      else if(CellMaxJ[q]<yLRCstraight)//inside curved part rootcap: ignore growth 
	Rgrow[q]=0.0000001;
#ifdef PLTDEPZONATION
      else if(Plts[q]>15)//MZ and in straight part: grow & divide
#else
      else if(CellMinJ[q]<yLRC1)//MZ, TA and TZ
#endif
	{
	  double distfac=1;
	  double dist=CellMinJ[q]-yLRCstraight;
	  double max=1;//2;//1.75
	  double min=0.;//0.25;//0.5
	  double maxdist=yMZEZ-yLRCstraight;
	  double ksat=0.3*maxdist;//0.5*maxdist;
	  double ksat2=0.1*maxdist;
	  distfac=(max-min)*(ksat*ksat/(ksat*ksat+dist*dist))+min;
	 
	  Rgrow[q]=Rdiv[q]*distfac;
	}
      else// EZ and DZ expand and or differentiate
	{
	  //EZ: expand and differentiate
	  //realize that if root cap is not dying
	  //cells alongside EZ will not be able to
	  //expand any further
	  if(CellHeight[q]<Hmax && Diff[q]<85)
	    Rgrow[q]=Relong[q];
	  else
	    Rgrow[q]=0.0000001;
	}
    }

  int count = 0;
  for(q=0;q<actcells;q++)
    {
      
      if(JustChecked[q]==0)
	{
	  H=CellHeight[q];

	  if(CellMaxJ[q]<yR)//SCN: ignore growth
	    {
	      CellZonationState[q]=0;
	      JustChecked[q]=1;
	    }
	  else if(CellMaxJ[q]<yLRCstraight)//curved part MZ: ignore growth
	    {
	      CellZonationState[q]=30;
	      JustChecked[q]=1;
	    }
#ifdef PLTDEPZONATION
	  else if(Plts[q]>15)//MZ: TA part with division, TZ part with only growth
#else
	  else if(CellMinJ[q]<yLRC1) //! 
#endif
	    {	
	     
	      int meani=(int)(0.5*(CellMinI[q]+CellMaxI[q]));
	      int meanj=(int)(0.5*(CellMinJ[q]+CellMaxJ[q]));
	      int celltype=Tct[meani][meanj];
	      int TZboundary;

	      if(celltype==4)//lateral root cap
		TZboundary=yLRCstraight+5*HMZ+5;
	      else if(celltype>=8 && celltype<=11)//vasculature
		TZboundary=yLRC1-15*HMZ-15;
	      else
		TZboundary=yLRC1-10*HMZ-10;



	      
	      if(CellMinJ[q]<=TZboundary)//TA: division
		{
		   CellZonationState[q]=30;
		   JustChecked[q]=1;
		}
	      else//only growth
		{
		   CellZonationState[q]=50;
		   JustChecked[q]=1;
		}

	      if(H>Hdiv && CellMinJ[q]>TZboundary)//division
		{
		  
		  DivideCell(time,q);
		  q=-1;
		  
		}
	      else
		{
#ifdef RANDOMGROWTH
		  if((100*RandNr[CellMinJ[q]])<(100*0.000198))
		    {
		      TimePrevGrowth[q]=time;
		      GrowCell(time,q,0);
		      q=-1;
		    }
#endif
#ifdef EXPONENTIALGROWTH
		  tgrowth=1./(Rgrow[q]*CellHeight[q]);		      
		  if(time>=TimePrevGrowth[q]+tgrowth)
		    {
		      TimePrevGrowth[q]=time;
		      GrowCell(time,q,0);
		      q=-1; 
		    } 
#endif
#ifdef LINEARGROWTH
		  tgrowth=1./(Rgrow[q]);
		  if(time>=TimePrevGrowth[q]+tgrowth)
		    {
		      TimePrevGrowth[q]=time;
		      GrowCell(time,q,0);
		      q=-1; 
		    } 
#endif 
		}
	    }
	  else//EZ or  DZ
	    {
	      JustChecked[q]=1;
	      //differentiation starts in EZ, proceeds in DZ

	      if((int)1000*Diff[q]==0)//only at start of diff
		Diff[q]+=0.001;
	      else
		Diff[q]+=tstep*speedup2*(diffrate-decaydiffrate*Diff[q]);

	      if(Diff[q]<85)//not into terminal differentiation
		{
		  CellZonationState[q]=60;

		  if(H<Hmax)//still allowed to expand
		    {	
#ifdef RANDOMEXPANSION
		      if((100*RandNr[CellMinJ[q]])<(100*0.00229))
			{
			  TimePrevGrowth[q]=time;
			  GrowCell(time,q,0);
			  q=-1;
			}
#endif	
#ifdef EXPONENTIALEXPANSION
		      tgrowth=1./(Rgrow[q]*CellHeight[q]);
		      if(time>=TimePrevGrowth[q]+tgrowth)
			{
			  TimePrevGrowth[q]=time;
			  GrowCell(time,q,1);
			  q=-1;
			}
#endif
#ifdef LINEAREXPANSION
		      tgrowth=1./(Rgrow[q]);
		      if(time>=TimePrevGrowth[q]+tgrowth)
			{
			  TimePrevGrowth[q]=time;
			  GrowCell(time,q,1);
			  q=-1;
			}
#endif	
		    }
		  else
		    {
		      CellZonationState[q]=100;  
		      
		    } 
		}	             
	    }
	}
    }
}

  

void GrowCell(int time,int q,int growthtype)
{
  int i,j;
  int istart;
  int istop;
  int jstart;
  int jstop;
  double oldh,newh;
  double oldv,newv;
  double volratTF,volratnonTF;

   
  //shift all those cells lying above cell q, 
  //+ its above lying wall + its top membrane 
  //one row upward
  //do this for cell and directly nb wall

  if(CellMinI[q]<n/2)//left cell
    {
      istart=CellMinI[q]-1;//only left cell wall
      istop=CellMaxI[q];//to prevent double shifting

      //to make sure also the middlemost cell wall
      //is being shifted up either the cell left or
      //right of it has to take it along
      if(CellMaxI[q]==(n/2)-1)
	istop=CellMaxI[q]+1;
    }
  else
    {
      istart=CellMinI[q];//to prevent double shifting
      istop=CellMaxI[q]+1;//only right cell wall
    }
  jstart=CellMaxJ[q];//top membrane
  jstop=m-2;
  for(j=jstop;j>=jstart;j--)//j>=jstart so including topmembrane cell q
    for(i=istart;i<=istop;i++)
      {
	//shift cell, membrane, wall locations
	Tc[i][j+1]=Tc[i][j];
	Tct[i][j+1]=Tct[i][j];
	Tmt[i][j+1]=Tmt[i][j];
	Cell[i][j+1]=Cell[i][j];
	//shift Pin/Lax3/Lax2/Aux1
	PinPrePat[i][j+1]=PinPrePat[i][j];
	Aux1PrePat[i][j+1]=Aux1PrePat[i][j];
	Lax3PrePat[i][j+1]=Lax3PrePat[i][j];

	//shift auxin levels
	Caux1[i][j+1]=Caux1[i][j];
      }
  
  //now add a row to cell q and the directly nb wall 
  //and turn it (except for sides) into intracellular
  //instead of membrane space
  j=CellMaxJ[q]-1;
  oldh=CellHeight[q];
  //non-TF
  //grow from h=4 to h=9 so +5 but than add walls so -2, so effectively 4+3=7 so +3 so 3/5=0.6
  newh=oldh+0.6;//oldh+1;
  oldv=oldh*CellWidth[q];
  newv=newh*CellWidth[q];
  volratnonTF=(double)oldv/(double)newv;
  //TF
  //assume large part is not in cytoplasm and hence not diluted
  newh=oldh+0.6;//+0.15;//oldh+1;
  oldv=oldh*CellWidth[q];
  newv=newh*CellWidth[q];
  double fractcyto=0.5;
  volratTF=(fractcyto*((double)oldv/(double)newv)+(1-fractcyto));
  for(i=istart;i<=istop;i++)
    {
      //newly aroson gap is now filled with extra row by copying below row
      //so j=CellMaxJ[q]-1 was earlier one but topmost row cell q, just below membrane
      //and j+1 earlier was topmost row cell q, membrane, but is now changed into similar
      //state as j
      Tc[i][j+1]=Tc[i][j];
      Tct[i][j+1]=Tct[i][j];
      Tmt[i][j+1]=Tmt[i][j];
      Cell[i][j+1]=Cell[i][j];
      //correct Pin/Lax3/Lax2/Aux1 in extra lateral membrane?! (dilute??)
      PinPrePat[i][j+1]=PinPrePat[i][j];
      Aux1PrePat[i][j+1]=Aux1PrePat[i][j]; 
      Lax3PrePat[i][j+1]=Lax3PrePat[i][j];
      //nothing is done about auxin level so total auxin in
      //cell is not increasing?, so always diluted??
      //No, topmembrane cell q is shifted: takes along Caux1
      //lower part cell q is unchanged: keeps old Caux1
      //newly arosen gap is not overwritten: keesp old Caux1
      //so net increase of Caux1!
    }
  
  //DILUTE AUXIN!
  /*
  for(i=istart;i<=istop;i++)
    for(j=CellMinJ[q];j<=CellMaxJ[q]+1;j++)
      {
	Caux1[i][j]*=oldh/(oldh+1.);
      }
  */


  
  //implicit consideration of cytoplasmic or vacuolar growth
  //does not work when it is a substance undergoing diffusion
  //in that case, during vacuolar growth, the concentration
  //in the cytoplasm should stay the same, but so does the
  //amount of cytoplasm and hence the amount available for
  //diffusion, however by not explicitly considering cytoplasm
  //and vacuoles it appaers that concentration in cytoplasm
  //stays the same but volume increases and hence available
  //amount increases
  //auxin and PLTs diffuse
  //now PLTs do not dilute upon vacuolar growth, auxin does

  //dilute gene expression levels 
  if(growthtype==0)//cytoplasmic
    {

      //TF
      ARF[q]*=volratTF;
      AA[q]*=volratTF;
      BB[q]*=volratTF;
      CC[q]*=volratTF;
      DD[q]*=volratTF;
      Plt[q]*=volratTF;
      Plts[q]*=volratTF;
      //Diff[q]*=volratTF;
     

      //non-TF
#ifdef PINREGULATED
      Pin[q]*=volratnonTF;
#endif
#ifdef YUC3GH33REGULATED
      Yuc3[q]*=volratnonTF;
      Gh33[q]*=volratnonTF;
#endif
#ifdef AUX1REGULATED
      Aux1[q]*=volratnonTF;
#endif
#ifdef LAX3PREPATTERN
	  Lax3[q]*=volratnonTF;
#endif
    }
  //else//vacuolar, no dilution of cytoplasmic conc
   
  
  TimePrevGrowth[q]=time;
  //in case of growth: do not renumber the cells
  //in this case lower left corner of cells may shift
  //so our method of mapping old to new cell ids 
  //does not work, as it assumes that lower left
  //corners of cells do not change, which is only
  //true during cell division (apart from new cell)
  //and cell culling (apart from removed cells)!!!!!
  //instead we just maintain old cell numbering
  //but make sure cells grow and cells above it shift
  //the recomputing off cellcorners and sizes does
  //work then
  FindCellCorners();
  FindCellSizes();
  CullOverflowCells(time); 
#ifndef SMBMUTANT
  CullLateralRootcap(time);
#endif
}


void DivideCell(int time,int q)
{
  int i,j;
  int divtime;
  int istart;
  int istop;
  int jstart;
  int jstop;
  int jwall;
  double meani,meanj;
  int oldid,newid,aboveid,oldmini,oldminj;
  static int first_time=0;
  static int timememory;
  double R1,R2;
  int jump=53;
  int second;
  if(first_time==0)
    {
      timememory=-1;
      first_time=1;
    }

  //first time for this particular timestep that divide cell is called 
  if(time!=timememory)
    {
      for(j=yLRCstraight;j<m;j++)//fill array with new random numbers
	RandNr[j]=uniform();
    }

  //find random numbers for top and bottom daughter cell
  R1=RandNr[CellMinJ[q]];//random number for top daughter cell
  second=CellMinJ[q]+jump;
  if(second>=m-1)
    second=second-(m-1);
  R2=RandNr[second];//random number for bottom daughter cell
 


  //cell q is up for a division
  istart=CellMinI[q];
  istop=CellMaxI[q];
  jwall=CellHeight[q]/2;

  for(i=istart;i<=istop;i++)
    {
      //make wall:
      j=CellMinJ[q]+jwall;//wall
      Tc[i][j]=0;//wall
      Tct[i][j]=20;//wall
      Tmt[i][j]=0;//wall

      //make membrane above wall: bottom membrane top daughter cell
      j=CellMinJ[q]+jwall+1;//above wall
      Tc[i][j]=2;//membrane
      Tmt[i][j]=2;//bottom membrane 
      //copy protein pattern from bottom membrane mother cell
      PinPrePat[i][j]=PinPrePat[i][CellMinJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[i][CellMinJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[i][CellMinJ[q]]; 
      //make membrane below wall: top membrane lower daughter cell
      j=CellMinJ[q]+jwall-1;//below wall
      Tc[i][j]=2;//membrane
      Tmt[i][j]=1;//top membrane
      //copy protein pattern from top membrane mother cell
      PinPrePat[i][j]=PinPrePat[i][CellMaxJ[q]];
      Aux1PrePat[i][j]=Aux1PrePat[i][CellMaxJ[q]];
      Lax3PrePat[i][j]=Lax3PrePat[i][CellMaxJ[q]]; 
    }
 
  //Make sure to store old cell identities, locations,
  //and corresponding properties before doing division
  //clean the arrays
  int oldactcells=actcells;
  StoreOldSituation(oldactcells);
  //old identity dividing cell + location
  oldid=q;
  oldmini=CellMinI[q];
  oldminj=CellMinJ[q];
  //renumber cells after division
  NumberCells();
  FindCellCorners();
  FindCellSizes();
  //map old identities cells to their new ones
  MapOldToNewSituation(oldactcells);
  //find new identity dividing cell
  newid=Cell[oldmini][oldminj];
  //find identity top daughter cell
  aboveid=Cell[CellMinI[newid]][CellMaxJ[newid]+3];
  //make sure oldid maps to newid and aboveid



#ifndef RANDOMGROWTH
  double divtime1,divtime2;
  double elongtime1,elongtime2;
  double mu;
  double sigma;
  double sumdiv;
  double divrate;
  double sumelong;
  double elongrate;
  double steptime;
  
  //compute division growth rate
  /*mu=avgdivtime;
  sigma=varperc*mu;
  divtime1=((gauss[(int)(R1*10000)]*sigma+mu));
  //mu=divtime1;
  //sigma=varperc*mu;
  divtime2=((gauss[(int)(R2*10000)]*sigma+mu));*/


  //divtime=sin(phase)*3.5*3600+avgdivtime;
  //divtime=sin(phase)*2*3600+avgdivtime;
  divtime1=avgdivtime;//divtime+(R1-0.5)*0.5*3600;
  divtime2=avgdivtime;//divtime+(R2-0.5)*0.5*3600;

  //to mimick the QC/SCN slowly producing new cells
  //we displace this characteristic division pattern
  //to the lowermost cells capable of dividing in our
  //simulations: the row just above yR
 
  

  /*
  if(Tct[CellMinI[newid]][CellMinJ[newid]]!=1)//non-lrc
    {
      //newid is bottom daughter cell
      //aboveid is top daughter cell
      
      //if second lowest one divides also asymmetric:
      //bottom one slow, top one normal
      int cellcounter=0;
      int cellid=newid;
      j=CellMinJ[newid];
      i=CellMinI[newid]+1;
      while(j>yLRCstraight)
	{
	  if(Cell[i][j]==cellid)//same cell
	    {
	      j--;
	    }
	  else if(Cell[i][j]==-1)//wall
	    {
	      j--;
	    }
	  else
	    {
	      cellcounter++;
	      cellid=Cell[i][j];
	      j--;
	    }
	}
      if(cellcounter==0)
	{
	  divtime2=1.5*divtime2;
	  divtime1=1.*divtime1;
	}
    }
  */


  

#ifdef EXPONENTIALGROWTH
  sumdiv=0;
  for(i=HMZ;i<=2*HMZ;i++)
    sumdiv+=(1./((double)i));
  divrate=sumdiv/divtime1;
  Rdiv[aboveid]=divrate;
  divrate=sumdiv/divtime2;
  Rdiv[newid]=divrate;
#endif
#ifdef LINEARGROWTH
  steptime=divtime1/HMZ;
  divrate=1./steptime;
  Rdiv[aboveid]=divrate;
  steptime=divtime2/HMZ;
  divrate=1./steptime;
  Rdiv[newid]=divrate;
#endif
  elongtime1=avgelongtime;
  elongtime2=avgelongtime;
#ifdef EXPONENTIALEXPANSION
  sumelong=0;
  for(i=((int)2*HMZ);i<=Hmax;i++)//for(i=((int)1.5*HMZ);i<=Hmax;i++)
    sumelong+=(1./((double)i));
  elongrate=sumelong/elongtime1;
  Relong[aboveid]=elongrate;
  elongrate=sumelong/elongtime2;
  Relong[newid]=elongrate;
#endif
#ifdef LINEAREXPANSION
  steptime=elongtime1/(Hmax-((int)(2*HMZ)));//elongtime1/(Hmax-((int)(1.5*HMZ)));
  elongrate=1./steptime;
  Relong[aboveid]=elongrate;
  steptime=elongtime2/(Hmax-((int)(2*HMZ)));//elongtime2/(Hmax-((int)(1.5*HMZ)));
  elongrate=1./steptime;
  Relong[newid]=elongrate;
#endif	  
#endif
  TimePrevGrowth[aboveid]=time;
  TimePrevGrowth[newid]=time;
 
		       


  //if no noise you have to switch on this one!


  CellDivNr[aboveid]=CellDivNr[newid]+1;
  CellDivNr[newid]=CellDivNr[newid]+1;
  if(CellMinJ[newid]==(yLRCstraight+1))
    CellDivNr[newid]=0;

  ARF[aboveid]=ARF[newid];
  AA[aboveid]=AA[newid];
  BB[aboveid]=BB[newid];
  CC[aboveid]=CC[newid];
  DD[aboveid]=DD[newid];
  Plt[aboveid]=Plt[newid];
  Plts[aboveid]=Plts[newid];
  PP[aboveid]=PP[newid];
  Pin[aboveid]=Pin[newid];
  Yuc3[aboveid]=Yuc3[newid];
  Gh33[aboveid]=Gh33[newid];
  Aux1[aboveid]=Aux1[newid];
  Lax3[aboveid]=Lax3[newid];
  MeanCells[aboveid]=MeanCells[newid];
  Rgrow[aboveid]=Rgrow[newid];
  Rgrowavg[aboveid]=Rgrowavg[newid];
  JustChecked[aboveid]=JustChecked[newid];//!!
  CellZonationState[aboveid]=CellZonationState[newid];
  CellsInOZ[aboveid]=CellsInOZ[newid];
  Diff[aboveid]=Diff[newid];
 
  q=-1;

  timememory=time;
}


void CullOverflowCells(int time)
{
  //due to the growth, cells get pushed over the edge
  //these cells need to be removed as soon as their
  //above cell wall drops over the edge to make sure
  //that only entire cells are part of the simulation
  //this automatically ensures that cell numbers do
  //not increase indefinetely

  int i,j,q;
  int ii,jj,iii,jjj;
  int counter;

  //scan line below topline
  //if still ok, it contains only external (3) or wall (0)
  //if culling is needed, it contains cytoplasm (1) or membrane (2) 
  //we do line below topline, as we need topline to create artificial
  //membrane/cell part for correct influx/efflux relation between
  //root and shoot


  int culling[totcells];
  for(q=0;q<totcells;q++)
    culling[q]=0;

  //first determine which cells need to be culled
  j=m-2;
  for(i=0;i<n;i++)
    {
      if(Tc[i][j]==1 || Tc[i][j]==2)//culling needed!
	{
	  //which cell is sitting here?
	  q=Cell[i][j];
	  culling[q]=1;
	}
    }
  counter=0;
  for(q=0;q<totcells;q++)
    {
      if(culling[q]==1)
	{
	  counter++;
	  //printf("time %i cell %i needs culling\n",time,q);
	}
    }
  if(counter>0)//at least one cell culled
    {
      //now do the GRID based adjustments:
      //find where it sits in the field and remove it
      
      for(q=0;q<totcells;q++)
	{
	  if(culling[q]==1)
	    {
	      
	      //removing cell itself+ wall above
	      //and if left cell left wall
	      //if cell directly left of middle also right wall
	      //and if right cell right wall
	      int mini;
	      int maxi;
	      if(CellMinI[q]<xm)
	        {
		 mini=CellMinI[q]-1;
                 maxi=CellMaxI[q];
                 if(CellMaxI[q]==(xm-1))
		   maxi+=1;
                }
	      else
                {
		  mini=CellMinI[q];
		  maxi=CellMaxI[q]+1; 
	        }
	      
	      for(ii=mini;ii<=maxi;ii++)
		for(jj=CellMinJ[q];jj<=(CellMaxJ[q]+1);jj++)
		  {    
		    //put all to non-tissue status
		    Tc[ii][jj]=3;
		    Tct[ii][jj]=0;
		    Tmt[ii][jj]=0;
		    PinPrePat[ii][jj]=0;
		    //more to come
		    Cell[ii][jj]=-1;
		    Caux1[ii][jj]=-10;//0;		      
		  }
	    }
	}

      //next do the CELL based readjustments:
      int oldactcells=actcells;
      StoreOldSituation(oldactcells);
      NumberCells();
      FindCellCorners();
      FindCellSizes();
      MapOldToNewSituation(oldactcells);
    }
}

void CullLateralRootcap(int time)
{

  int i,j,k,ii,jj,iii,jjj;
  int q,qq;
  int meanJ;
  FILE *f;
  char s[1000];
  sprintf(s,"%s/Lateralrootcapculling",dirname);

  f=fopen(s,"a");

  for(k=0;k<2;k++)
    {
      if(k==0)
	{
	  //check left lateral root cap:
	  i=disttolrc+1;
	}
      else
	{
	  //check right lateral root cap
	  i=n-1-(disttolrc+1);
	}
      for(j=m-1;j>=0;j--)
	{
	  if(Tc[i][j]==2)//uppermost lateral root cap found
	    {
	      q=Cell[i][j];
	
  
#ifdef PLTDEPZONATION
	      //find neighbouring epidermal cell
	      meanJ=0.5*(CellMinJ[q]+CellMaxJ[q]);
	      ii=i;
	      if(k==0)//left root cap so epidermis to the right
		{
		  while(Cell[ii][j]==Cell[i][j] || Cell[ii][j]==-1)
		    ii++;
		}
	      else//right root cap so epidermis to the left
		{
		  while(Cell[ii][j]==Cell[i][j] || Cell[ii][j]==-1)
		    ii--;
		}
	      
	      qq=Cell[ii][j];
	      if(Plts[qq]<15)//no longer MZ
#else
	      if(CellMinJ[q]>yLRC1)//PERHAPS THIS THAN SHOULD BE yMZEZ, ONCE ADJUSTED
#endif  
		{
		  
		  fprintf(f,"%f 1\n",((double)time/3600.));

		  //removing cell itself+ wall above
		  for(ii=CellMinI[q];ii<=CellMaxI[q];ii++)
		    for(jj=CellMinJ[q];jj<=(CellMaxJ[q]+1);jj++)
		      {    
			//put all to non-tissue status
			Tc[ii][jj]=3;
			Tct[ii][jj]=0;
			Tmt[ii][jj]=0;
			PinPrePat[ii][jj]=0;
			//more to come
			Cell[ii][jj]=-1;
			Caux1[ii][jj]=-10;//0;		      
		      }
		  
		  if(k==0)
		    {
		      //wall left can go for left lrc
		      iii=CellMinI[q]-1;
		      for(jjj=CellMinJ[q];jjj<=(CellMaxJ[q]+1);jjj++)
			{
			  Tc[iii][jjj]=3;
			  Tct[iii][jjj]=0;
			  Tmt[iii][jjj]=0;
			  Cell[iii][jjj]=-1;
			  Caux1[iii][jjj]=-10;//0;
			}
		    }
		  else 
		    {
		      //wall right can go for right lrc
		      iii=CellMaxI[q]+1;
		      for(jjj=CellMinJ[q];jjj<=(CellMaxJ[q]+1);jjj++)
			{
			  Tc[iii][jjj]=3;
			  Tct[iii][jjj]=0;
			  Tmt[iii][jjj]=0;
			  Cell[iii][jjj]=-1;
			  Caux1[iii][jjj]=-10;//0;
			}
		    }
		  int oldactcells=actcells;
		  StoreOldSituation(oldactcells);
		  NumberCells();
		  FindCellCorners();
		  FindCellSizes();
		  MapOldToNewSituation(oldactcells);
		}
	      else
		{
		  //fprintf(f,"%f 0\n",((double)time/3600.));
		}
	    }
	}
    }
  fclose(f);
}



void StoreOldSituation(int oldactcells)
{
  int i,k;

  //Make sure to store old cell identities, locations,
  //and corresponding properties before doing division
  //clean the arrays
  for(i=0;i<totcells;i++)
    {
      OldSit[i][0]=-1;
      OldSit[i][1]=-1;
      OldSit[i][2]=-1;
      
      OldTimePrevGrowth[i]=-1;
      OldARF[i]=-1;
      OldAA[i]=-1;
      OldBB[i]=-1;
      OldCC[i]=-1;
      OldDD[i]=-1;
      OldPlt[i]=-1;
      OldPlts[i]=-1;
      OldPltsexpr[i]=-1;
      OldPP[i]=-1;
      OldPin[i]=-1;
      OldYuc3[i]=-1;
      OldGh33[i]=-1;
      OldAux1[i]=-1;
      OldLax3[i]=-1;
      OldMeanCells[i]=-1;
      OldRgrow[i]=-1;
      OldRgrowavg[i]=-1;
      OldRdiv[i]=-1;
      OldRelong[i]=-1;
      OldCellZonationState[i]=-1;
      OldCellDivNr[i]=-1;
      OldCellsInOZ[i]=-1;
      OldDiff[i]=-1;
      OldJustChecked[i]=-1;
    }
  //fill them
  for(i=0;i<oldactcells;i++)
    {
      OldSit[i][0]=i;//old cell nr
      OldSit[i][1]=CellMinI[i];//min i value
      OldSit[i][2]=CellMinJ[i];//min j value
      
      OldTimePrevGrowth[i]=TimePrevGrowth[i];
      OldARF[i]=ARF[i];
      OldAA[i]=AA[i];
      OldBB[i]=BB[i];
      OldCC[i]=CC[i];
      OldDD[i]=DD[i];
      OldPlt[i]=Plt[i];
      OldPlts[i]=Plts[i];
      OldPltsexpr[i]=Pltsexpr[i];
      OldPP[i]=PP[i];
      OldPin[i]=Pin[i];
      OldYuc3[i]=Yuc3[i];
      OldGh33[i]=Gh33[i];
      OldAux1[i]=Aux1[i];
      OldLax3[i]=Lax3[i];
      OldMeanCells[i]=MeanCells[i];
      OldRgrow[i]=Rgrow[i];
      OldRgrowavg[i]=Rgrowavg[i];
      OldRdiv[i]=Rdiv[i];
      OldRelong[i]=Relong[i];
      OldCellZonationState[i]=CellZonationState[i];
      OldCellDivNr[i]=CellDivNr[i];
      OldCellsInOZ[i]=CellsInOZ[i];
      OldDiff[i]=Diff[i];
      OldJustChecked[i]=JustChecked[i];
    } 
}


void MapOldToNewSituation(int oldactcells)
{
  int i,j,k;

  //map old identities cells to their new ones
  for(i=0;i<actcells;i++)//new cells
    for(j=0;j<oldactcells;j++)//old cells
      {
	if(OldSit[j][1]==CellMinI[i] && OldSit[j][2]==CellMinJ[i])
	  MapCellNrs[i]=j;//new cell i was old cell j
      }

   for(i=0;i<actcells;i++)
     {
       TimePrevGrowth[i]=OldTimePrevGrowth[MapCellNrs[i]];
       ARF[i]=OldARF[MapCellNrs[i]];
       AA[i]=OldAA[MapCellNrs[i]];
       BB[i]=OldBB[MapCellNrs[i]];
       CC[i]=OldCC[MapCellNrs[i]];
       DD[i]=OldDD[MapCellNrs[i]];
       Plt[i]=OldPlt[MapCellNrs[i]];
       Plts[i]=OldPlts[MapCellNrs[i]];
       Pltsexpr[i]=OldPltsexpr[MapCellNrs[i]];
       PP[i]=OldPP[MapCellNrs[i]];
       Pin[i]=OldPin[MapCellNrs[i]];
       Yuc3[i]=OldYuc3[MapCellNrs[i]];
       Gh33[i]=OldGh33[MapCellNrs[i]];
       Aux1[i]=OldAux1[MapCellNrs[i]];
       Lax3[i]=OldLax3[MapCellNrs[i]];
       MeanCells[i]=OldMeanCells[MapCellNrs[i]];
       Rgrow[i]=OldRgrow[MapCellNrs[i]];
       Rgrowavg[i]=OldRgrowavg[MapCellNrs[i]];
       Rdiv[i]=OldRdiv[MapCellNrs[i]];
       Relong[i]=OldRelong[MapCellNrs[i]];
       CellZonationState[i]=OldCellZonationState[MapCellNrs[i]];  
       CellDivNr[i]=OldCellDivNr[MapCellNrs[i]];  
       CellsInOZ[i]=OldCellsInOZ[MapCellNrs[i]];
       Diff[i]=OldDiff[MapCellNrs[i]];
       JustChecked[i]=OldJustChecked[MapCellNrs[i]];
     }
}

