#include "Header.hh"

void ExtraMeasurements(int t)
{
  FILE *f;
  char s[2050];
  int toplrc;
  int sizetoplrc;
  double auxlrc;
  int pospinflip;
  int i,j;

  //top position lateral root cap
  //size topmost lateral root cap cell
  //auxin level topmost lateral root cap cell
  toplrc=-1;
  sizetoplrc=-1;
  i=disttolrc+1;
  j=m-1;
  while(Tc[i][j]==3)
    j--;
  if(!(Tct[i][j-1]==1))
    {
      printf("something is wrong in finding top lrc\n");
      exit(1);
    }
  else
    {
      toplrc=j-1;
      sizetoplrc=CellHeight[Cell[i][j-1]];
      auxlrc=MeanCells[Cell[i][j-1]];
    }

  //position pin flip in cortex
  pospinflip=-1;
  i=disttoepi+sizeepi+2;
  j=m-1;
  while(!(Tmt[i][j]==2 && PinPrePat[i][j]==1))
    j--;
  pospinflip=j;

  //sizes of vasc cells in OZ
  //2, 4, 8 or 16 cells nearest yLRC1
  int vascsizescellsup[8];
  int vascsizescellsdown[8];
  int counterup;
  int counterdown;
  int qq;
  for(i=0;i<8;i++)
    {
      vascsizescellsup[i]=-1;
      vascsizescellsdown[i]=-1;
    }
  i=disttoepi+totsizeepi+totsizecort+totsizeendo+totsizeperi+1;
  j=yLRC1;
  if(Cell[i][j]==-1)
    j++;
  //printf("just checking: cell %i type %i (should be 9) pos %i,%i\n",Cell[i][j],Tct[i][j],i,j);

  //go up
  counterup=0;
  while(counterup<8 && Tc[i][j]!=3)
    {
      qq=Cell[i][j];
      while(Cell[i][j]==qq)
	j++;
      vascsizescellsup[counterup]=CellHeight[qq];
      counterup++;
      j++;
    }
  //restart, now go down
  j=yLRC1;
  if(Cell[i][j]==-1)
    j+1;
  //we had this cell so first find next one
  qq=Cell[i][j];
  while(Cell[i][j]==qq)
    j--;
  j--;//skip wall
  counterdown=0;
  while(counterdown<8 && Tc[i][j]!=3)
    {
      qq=Cell[i][j];
      while(Cell[i][j]==qq)
	j--;
      vascsizescellsdown[counterdown]=CellHeight[qq];
      counterdown++;
      j--;
    }
  //for(i=0;i<8;i++)
  //printf("cell i %i up %i down %i\n",i,vascsizescellsup[i],vascsizescellsdown[i]);

  double vascmaxnearest=0;
  double vascavgsize2=0;
  double vascavgsize4=0;
  double vascavgsize8=0;
  double vascavgsize16=0;
  double vascavgsize1up=0;
  double vascavgsize2up=0;
  double vascavgsize4up=0;
  double vascavgsize8up=0;
  double vascavgsize1down=0;
  double vascavgsize2down=0;
  double vascavgsize4down=0;
  double vascavgsize8down=0;
  for(i=0;i<8;i++)
    {
      vascavgsize16+=(vascsizescellsup[i]+vascsizescellsdown[i]);
      vascavgsize8up+=vascsizescellsup[i];
      vascavgsize8down+=vascsizescellsdown[i];
      if(i<4)
	{
	  vascavgsize8+=(vascsizescellsup[i]+vascsizescellsdown[i]);
	  vascavgsize4up+=vascsizescellsup[i];
	  vascavgsize4down+=vascsizescellsdown[i];
	}
      if(i<2)
	{
	  vascavgsize4+=(vascsizescellsup[i]+vascsizescellsdown[i]);
	  vascavgsize2up+=vascsizescellsup[i];
	  vascavgsize2down+=vascsizescellsdown[i];
	}
      if(i<1)
	{
	  vascavgsize2+=(vascsizescellsup[i]+vascsizescellsdown[i]);
	  vascavgsize1up+=vascsizescellsup[i];
	  vascavgsize1down+=vascsizescellsdown[i];
	}
      
      //printf("avgsize 16 %f 8 %f 4 %f\n",vascavgsize16,vascavgsize8,vascavgsize4);
    }
  if(vascsizescellsup[0]>vascsizescellsdown[0])
    vascmaxnearest=vascsizescellsup[0];
  else
    vascmaxnearest=vascsizescellsdown[0];
  vascavgsize2=(double)vascavgsize2/2.0;
  vascavgsize4=(double)vascavgsize4/4.0;
  vascavgsize8=(double)vascavgsize8/8.0;
  vascavgsize16=(double)vascavgsize16/16.0;
  //vascavgsize1up=(double)vascavgsize1up/1.0;
  vascavgsize2up=(double)vascavgsize2up/2.0;
  vascavgsize4up=(double)vascavgsize4up/4.0;
  vascavgsize8up=(double)vascavgsize8up/8.0;
  //vascavgsize1down=(double)vascavgsize1down/1.0;
  vascavgsize2down=(double)vascavgsize2down/2.0;
  vascavgsize4down=(double)vascavgsize4down/4.0;
  vascavgsize8down=(double)vascavgsize8down/8.0;
  //printf("avgsize 16 %f 8 %f 4 %f\n",vascavgsize16,vascavgsize8,vascavgsize4);

  //sizes of peri cells in OZ
  //2, 4, 8 or 16 cells nearest yLRC1
  int perisizescellsup[8];
  int perisizescellsdown[8];
  //int counterup;
  //int counterdown;
  //int qq;
  for(i=0;i<8;i++)
    {
      perisizescellsup[i]=-1;
      perisizescellsdown[i]=-1;
    }
  i=disttoepi+totsizeepi+totsizecort+totsizeendo+1;
  j=yLRC1;
  if(Cell[i][j]==-1)
    j++;
  //printf("just checking: cell %i type %i (should be 8)pos %i,%i\n",Cell[i][j],Tct[i][j],i,j);

  //go up
  counterup=0;
  while(counterup<8 && Tc[i][j]!=3)
    {
      qq=Cell[i][j];
      while(Cell[i][j]==qq)
	j++;
      perisizescellsup[counterup]=CellHeight[qq];
      counterup++;
      j++;
    }
  //restart, now go down
  j=yLRC1;
  if(Cell[i][j]==-1)
    j+1;
  //we had this cell so first find next one
  qq=Cell[i][j];
  while(Cell[i][j]==qq)
    j--;
  j--;//skip wall
  counterdown=0;
  while(counterdown<8 && Tc[i][j]!=3)
    {
      qq=Cell[i][j];
      while(Cell[i][j]==qq)
	j--;
      perisizescellsdown[counterdown]=CellHeight[qq];
      counterdown++;
      j--;
    }
  //for(i=0;i<8;i++)
  //printf("cell i %i up %i down %i\n",i,perisizescellsup[i],perisizescellsdown[i]);

  double perimaxnearest=0;
  double periavgsize2=0;
  double periavgsize4=0;
  double periavgsize8=0;
  double periavgsize16=0;
  double periavgsize1up=0;
  double periavgsize2up=0;
  double periavgsize4up=0;
  double periavgsize8up=0;
  double periavgsize1down=0;
  double periavgsize2down=0;
  double periavgsize4down=0;
  double periavgsize8down=0;
  for(i=0;i<8;i++)
    {
      periavgsize16+=(perisizescellsup[i]+perisizescellsdown[i]);
      periavgsize8up+=perisizescellsup[i];
      periavgsize8down+=perisizescellsdown[i];
      if(i<4)
	{
	  periavgsize8+=(perisizescellsup[i]+perisizescellsdown[i]);
	  periavgsize4up+=perisizescellsup[i];
	  periavgsize4down+=perisizescellsdown[i];
	}
      if(i<2)
	{
	  periavgsize4+=(perisizescellsup[i]+perisizescellsdown[i]);
	  periavgsize2up+=perisizescellsup[i];
	  periavgsize2down+=perisizescellsdown[i];
	}
      if(i<1)
	{
	  periavgsize2+=(perisizescellsup[i]+perisizescellsdown[i]);
	  periavgsize1up+=perisizescellsup[i];
	  periavgsize1down+=perisizescellsdown[i];
	}
      //printf("avgsize 16 %f 8 %f 4 %f\n",periavgsize16,periavgsize8,periavgsize4);
    }
  if(perisizescellsup[0]>perisizescellsdown[0])
    perimaxnearest=perisizescellsup[0];
  else
    perimaxnearest=perisizescellsdown[0];
  periavgsize2=(double)periavgsize2/2.0;
  periavgsize4=(double)periavgsize4/4.0;
  periavgsize8=(double)periavgsize8/8.0;
  periavgsize16=(double)periavgsize16/16.0;
  //periavgsize1up=(double)periavgsize1up/1.0;
  periavgsize2up=(double)periavgsize2up/2.0;
  periavgsize4up=(double)periavgsize4up/4.0;
  periavgsize8up=(double)periavgsize8up/8.0;
  //periavgsize1down=(double)periavgsize1down/1.0;
  periavgsize2down=(double)periavgsize2down/2.0;
  periavgsize4down=(double)periavgsize4down/4.0;
  periavgsize8down=(double)periavgsize8down/8.0;
  //printf("avgsize 16 %f 8 %f 4 %f\n",periavgsize16,periavgsize8,periavgsize4);


  sprintf(s,"%s/ExtraMeasurements",dirname);
  f=fopen(s,"a");
  fprintf(f,"%i\t%i\t%i\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",t,toplrc,sizetoplrc,auxlrc,pospinflip,perimaxnearest,periavgsize2,periavgsize4,periavgsize8,periavgsize16,periavgsize1up,periavgsize2up,periavgsize4up,periavgsize8up,periavgsize1down,periavgsize2down,periavgsize4down,periavgsize8down,vascmaxnearest,vascavgsize2,vascavgsize4,vascavgsize8,vascavgsize16,vascavgsize1up,vascavgsize2up,vascavgsize4up,vascavgsize8up,vascavgsize1down,vascavgsize2down,vascavgsize4down,vascavgsize8down);
  fclose(f);
  //2-3-4-5 toplrc,sizelrctopcell,auxinthere,pospinflip
  //6-10 peri max,2,4,8,16
  //11-14 peri up
  //15-18 peri down
  //19-23 vasc max,2,4,8,16
  //24-27 vasc up
  //28-31 vasc down
}

void TrackWallsSpaceTime(int t)
{
	FILE *f1, *f2;
	int i,ii, j, x, q, qq, qqup, qqdown;
	char s1[2050];
	char s2[2050];
	double auxin_ratio;
	i=totsizeendo+totsizecort+totsizeepi+disttoepi+1;//
	ii=totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;//n-1-i;  totsizeperi+
	sprintf(s1,"%s/TrackVascLPrevGrowthSpaceTime",dirname);
	sprintf(s2,"%s/TrackPeriLPrevGrowthSpaceTime",dirname);
	f1=fopen(s1, "a");
	f2=fopen(s2, "a");

	for(j=yLRCstraight; j<yLRC1+12*HEZ+12; j++)
	{
		

	if(Cell[i][j]!=-1)// && Tc[i][j]!=2)
		{
		q=Cell[i][j];
		qqup=Cell[CellMinI[q]][CellMaxJ[q]+2];
		qqdown=Cell[CellMinI[q]][CellMinJ[q]-2];
		auxin_ratio = MeanCells[q]/(.5*MeanCells[qqup]+.5*MeanCells[qqdown]);
		
		fprintf(f2, "%i\t%i\t%f\t%i\t%i\t%i\t%f\t%i\t%i\t%i\t%i\n", t,j,MeanCells[q], ProductionCounter[q], LastDiv_MinJ[q], t-LastDiv_t[q], Relong[q], TrackClones[q], CellHeight[q], CellDivNr[q], q);
		}
		else 
		{
			fprintf(f2, "%i\t%i\t%f\t%i\t%i\t%i\t%f\t%i\t%i\t%i\t%i\n", t,j,0.0,0,0,0,0.0,0,0,0,0);		
		}	
	}
	for(j=yLRCstraight; j<yLRC1+12*HEZ+12; j++)
	{	
		if(Cell[ii][j]!=-1)// && Tc[i][j]!=2)
		{
		qq=Cell[ii][j];	
		qqup=Cell[CellMinI[qq]][CellMaxJ[qq]+2];
		qqdown=Cell[CellMinI[qq]][CellMinJ[qq]-2];
		auxin_ratio = MeanCells[qq]/(.5*MeanCells[qqup]+.5*MeanCells[qqdown]);	
			
		fprintf(f1, "%i\t%i\t%f\t%i\t%i\t%i\t%f\t%i\t%i\t%i\t%i\n", t,j,MeanCells[qq], ProductionCounter[qq] ,LastDiv_MinJ[qq], t-LastDiv_t[qq],Relong[qq],TrackClones[qq], CellHeight[qq], CellDivNr[qq], qq);
		}
		else 
		{
			fprintf(f1, "%i\t%i\t%f\t%i\t%i\t%i\t%f\t%i\t%i\t%i\t%i\n", t,j,0.0,0,0,0,0.0,0,0,0,0);
		}	
	}
		
	
	
	fprintf(f1,"\n");
	fprintf(f2,"\n");
	fclose(f1);
	fclose(f2);
	
}

void SaveTotAuxin(int t)
{
  FILE *f;
  int i,j;
  char s[2050];
  

  double Auxtot=0;
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Auxtot+=Caux1[i][j];

  sprintf(s,"%s/Totalauxin",dirname);
  f=fopen(s,"a");
  fprintf(f,"%i\t%f\t%f\n",t,Auxtot,Auxtot/(n*m));
  fclose(f);
}

void SaveTemp(int t,int II,int JJ)
{
  FILE *f;					
  char s[2050];
  int q, qqup, qqdown;
  double tgrowth, tgrowth_up,tgrowth_down,ratio, ratio_growth;
  q=Cell[II][JJ];
  if(q!=-1)
    {
	  qqup=Cell[CellMinI[q]][CellMaxJ[q]+2];
	  qqdown=Cell[CellMinI[q]][CellMinJ[q]-2];
	  tgrowth=(Rgrow[q]*CellHeight[q]);
	  tgrowth_up=(Rgrow[qqup]*CellHeight[qqup]);
	  tgrowth_down=(Rgrow[qqdown]*CellHeight[qqdown]);
	  ratio=(double) (CellHeight[q])/CellHeight[qqdown];
	  ratio_growth=tgrowth/tgrowth_down;
      sprintf(s,"%s/TemporalDynamicsPoint%i_%i",dirname,II,JJ);
      f=fopen(s,"a");
      //fprintf(f,"%i\t%f\t%f\t%f\t%f\t%f\t%f\n",t,MeanCells[q],ARF[q],ARFStorage[q][sizestorage-1],Plts[q],Pltsexpr[q],Diff[q]);
      fprintf(f,"%i\t%f\t%i\t%f\t%i\t%i\t%f\t%i\t%f\t%i\t%i\t%f\t%i\t%f\t%i\t%f\t%f\n",t,MeanCells[q],CellHeight[q],tgrowth,LastDiv_MinJ[q],t-LastDiv_t[q],MeanCells[qqup], CellHeight[qqup], tgrowth_up, LastDiv_MinJ[qqup], t-LastDiv_t[qqup],MeanCells[qqdown], CellHeight[qqdown], tgrowth_down, LastDiv_MinJ[qqdown], ratio, ratio_growth);
      fclose(f);
    }
}


void SaveLeftRightDiff(int t)
{
  int i,j,q;
  int lefti,righti;
  int leftjaux,rightjaux;
  int leftjaux2,rightjaux2;
  int leftjplt,rightjplt;
  int leftjdiff,rightjdiff;
  FILE *g;
  char s[2050];

  lefti=x0LRC1;
  righti=n-1-lefti;

  i=lefti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(MeanCells[q]<5)
	    {
	      leftjaux=j;
	      j=2*m;
	    }
	}
    }
  i=righti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(MeanCells[q]<5)
	    {
	      rightjaux=j;
	      j=2*m;
	    }
	}
    }
  i=lefti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(MeanCells[q]<10)
	    {
	      leftjaux2=j;
	      j=2*m;
	    }
	}
    }
  i=righti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(MeanCells[q]<10)
	    {
	      rightjaux2=j;
	      j=2*m;
	    }
	}
    }
  i=lefti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(Plts[q]<15)
	    {
	      leftjplt=j;
	      j=2*m;
	    }
	}
    }
  i=righti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(Plts[q]<15)
	    {
	      rightjplt=j;
	      j=2*m;
	    }
	}
    }
  i=lefti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(Diff[q]>85)
	    {
	      leftjdiff=j;
	      j=2*m;
	    }
	}
    }
  i=righti;
  for(j=0;j<m;j++)
    {
      if(Cell[i][j]!=-1)
	{
	  q=Cell[i][j];
	  if(Diff[q]>85)
	    {
	      rightjdiff=j;
	      j=2*m;
	    }
	}
    }


  sprintf(s,"%s/LeftRightDifferences",dirname);
  g=fopen(s,"a");
  fprintf(g,"%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\n",t,leftjaux,rightjaux,(leftjaux-rightjaux),leftjaux2,rightjaux2,(leftjaux2-rightjaux2),leftjplt,rightjplt,(leftjplt-rightjplt),leftjdiff,rightjdiff,(leftjdiff-rightjdiff));
  fclose(g);
}

void SaveGradCellularRes(int t)
{
  FILE *g;
  int i,ii,j,q;
  char s[2050];

  for(int k=0;k<8;k++)
    {
      if(k==0)
	{
	  //left epidermis
	  i=disttoepi+0.5*totsizeepi;
	  sprintf(s,"%s/Spatialdynamics_epiL_time%i",dirname,t);
	}
      else if(k==1)
	{
	  //right epidermis
	  ii=disttoepi+0.5*totsizeepi;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_epiR_time%i",dirname,t);
	}
      else if(k==2)
	{
	  //left cortex
	  i=disttoepi+totsizeepi+0.5*totsizecort;
	  sprintf(s,"%s/Spatialdynamics_cortexL_time%i",dirname,t);
	}
      else if(k==3)
	{
	  //right cort
	  ii=disttoepi+totsizeepi+0.5*totsizecort;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_cortexR_time%i",dirname,t);
	}
      else if(k==4)
	{
	  //left endodermis
	  i=disttoepi+totsizeepi+totsizecort+0.5*totsizeendo;
	  sprintf(s,"%s/Spatialdynamics_endoL_time%i",dirname,t);
	}
      else if(k==5)
	{
	  //right endodermis
	  ii=disttoepi+totsizeepi+totsizecort+0.5*totsizeendo;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_endoR_time%i",dirname,t);
	}
      else if(k==6)
	{
	  //left vasculature
	  i=disttoepi+totsizeepi+totsizecort+totsizeendo+totsizeperi+0.3*totsizevasc;
	  sprintf(s,"%s/Spatialdynamics_vascL_time%i",dirname,t);
	}
      else if(k==7)
	{
	  //right vasculature
	  ii=disttoepi+totsizeepi+totsizecort+totsizeendo+totsizeperi+0.3*totsizevasc;
	  i=n-1-i;
	  sprintf(s,"%s/Spatialdynamics_vascR_time%i",dirname,t);
	}
      
      
      g=fopen(s,"wb");
      for(j=0;j<m;j++)
	{
	  q=Cell[i][j];
	  if(q>=0)
	    fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,MeanCells[q],ARF[q],AA[q],BB[q],CC[q],DD[q],Plts[q],Pltsexpr[q],Diff[q],CellHeight[q]);
	  else if(Tc[i][j]==3)
	    fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,-10.0,-10.0,-10.0,-10.0,-10.0,-10.0,-10.0,-10.0,-10.0,-10);
	}
      fclose(g);
      
    }
}



void SaveGradGridRes(int time)
{
  FILE *ff1;
  FILE *ff2;
  char s1[2050];
  char s2[2050];
  int i,ii,j,k;
  int List[8]={1,5,6,7,8,100,100,100};
  
  for(k=0;k<8;k++)
    {	
      if(k==0)
	{
	  sprintf(s1,"%s/GridResolutionL_RC1_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_RC1_time%i",dirname,time);
	}
      if(k==1)
	{
	  sprintf(s1,"%s/GridResolutionL_Epi_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Epi_time%i",dirname,time);
	  
	}
      if(k==2)
	{
	  sprintf(s1,"%s/GridResolutionL_Cort_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Cort_time%i",dirname,time);
	  
	}
      if(k==3)
	{
	  sprintf(s1,"%s/GridResolutionL_Endo_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Endo_time%i",dirname,time);
	  
	}
      if(k==4)
	{
	  sprintf(s1,"%s/GridResolutionL_Peri_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Peri_time%i",dirname,time);
	  
	}
      if(k==5)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc1_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc1_time%i",dirname,time);
	  
	}
      if(k==6)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc2_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc2_time%i",dirname,time);
	  
	}
      if(k==7)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc3_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc3_time%i",dirname,time);
	  
	}
      
      
      
      
      ff1=fopen(s1,"w");
      ff2=fopen(s2,"w");	
      
      
      
      for(j=0;j< yLRCstraight;j++)
	{
	  
	  i=0;
	  
	  while(Tct[i][j]!=List[k]  && i<xm)
	    i++;
	  
	  if(Tct[i][j]==List[k])
	    {
	      i++;
	      ii=n-(1+i);
	      
	      if(Cell[i][j]!=-1)
		{
		  fprintf(ff1,"%i\t%i\t%f\t%f\t%f\n",i,j,Caux1[i][j],Cpin1M[i][j], Aux1M[i][j]);
		  fprintf(ff2,"%i\t%i\t%f\t%f\t%f\n",ii,j,Caux1[ii][j],Cpin1M[ii][j], Aux1M[ii][j]);
		}
	    }
	}
      for(j= yzero;j<yEND;j++)//for(j= yQC;j<yEND;j++)//yLRCstraight
	{
	  if(k==0)
	    i=1;
	  else if(k==1)
	    i=disttoepi+1;
	  else if(k==2)
	    i=totsizeepi+disttoepi+1;
	  else if(k==3)
	    i=totsizecort+totsizeepi+disttoepi+1;
	  else if(k==4)
	    i=totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==5)
	    i=totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==6)
	    i=sizevasc+totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==7)
	    i=xm-1;//2*sizevasc+totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  
	  ii=n-(1+i);
	  if(Cell[i][j]!=-1)
	    {
	      fprintf(ff1,"%i\t%i\t%f\t%f\t%f\n",i,j,Caux1[i][j],Cpin1M[i][j], Aux1M[i][j]);
	      fprintf(ff2,"%i\t%i\t%f\t%f\t%f\n",ii,j,Caux1[ii][j],Cpin1M[ii][j], Aux1M[ii][j]);
	    }
	}
      
      fclose(ff1);
      fclose(ff2);   
	  		
    }		             
 }
 
 void PBS_priming(int starttime, int time)
 {
	 FILE *g;
     char s[3000];
     sprintf(s,"%s/../../Spacing_PrimingReport",dirname);
     g=fopen(s,"a");
     int i, j;
     int cellTZ;
	 cellTZ = (int)(.3 * nrcellsstraightMZ*HMZ)+(int)(.3 * nrcellsstraightMZ);
		
     int cellcounter=0;
     
     j=yLRC1 - cellTZ;
     i=totsizeepi+disttoepi+1;
     int cellid=Cell[i][j];
      while(j>yLRCstraight + 1)
	{
	  if(Cell[i][j]==cellid)//same cell
	    {
	      j--;
	    }
	  else if(Cell[i][j]==-1)//wall
	    {
	      j--;
	    }
	  else
	    {
	      cellcounter++;
	      cellid=Cell[i][j];
	      j--;
	    }
	}

int type;

type = 0;
#ifdef SPECIALTZBOUNDARY
type = 1;
#endif

#ifdef VASCDIFFERENT //Cell larger

#ifndef VASCDIFFONLYRATE
type = 2;
#else

type = 4;
#endif
#endif

#ifdef VASCDIFFONLYRATE  

#ifndef VASCDIFFERENT
type=3;
#else
type = 4;
#endif
#endif   
			if(counter_priming > 1)	
						 fprintf(g, "%i\t%i\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%i\t%i\t%i\t%s\t%i\n", time-time_first_priming, cellcounter, CellProduction_peri, max_spacing, min_spacing, (double)(sum_of_spacing/(counter_priming-1)), (double)(max_period/3600), (double)(min_period/3600), (double)((sum_period)/(counter_priming-1)), counter_priming, (int)(avgdivtime/3600), type,dirname, nrcellsstraightMZ);
			else
						 fprintf(g, "%i\t%i\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%i\t%i\t%i\t%s\t%i\n", time-time_first_priming, cellcounter, CellProduction_peri, max_spacing, min_spacing, (double)(sum_of_spacing), (double) max_period, (double) min_period, (double) sum_period, counter_priming, (int)(avgdivtime/3600), type,dirname, nrcellsstraightMZ);			
					
			

	

fclose(g);				
} 

 void CloneSize(int time)
{
	FILE *g;
    char s[3000];
    sprintf(s,"%s/../CloneSize",dirname);
    g=fopen(s,"a");
	int i, j;
	int MZsize, TZ, num_clone, max_clone, min_clone, cellid, cellsize, sizeclone;
	TZ = (int)(.25 * nrcellsstraightMZ*HMZ)+(int)(.25 * nrcellsstraightMZ);
	MZsize = 0;
	max_clone = 0;
	min_clone = nrcellsstraightMZ;
	num_clone = 1;
	sizeclone=1;
	j=yLRC1 - TZ;
    i=totsizeepi+disttoepi+1; //Cortex
    cellid = Cell[i][j];
    cellsize = CellHeight[cellid];
    while(j>yLRCstraight + 1)
	{
	  if(Cell[i][j]==cellid)//same cell
	    {
	      j--;
	    }
	  else if(Cell[i][j]==-1)//wall
	    {
	      j--;
	    }
	  else
	    {
	      MZsize++;
	      cellid=Cell[i][j];
	      
	      if(CellHeight[cellid] == cellsize)
			sizeclone++;
		  else
		  {
			  cellsize = CellHeight[cellid];
			  if(sizeclone<min_clone)
				min_clone=sizeclone;
			  else if(sizeclone>max_clone)
				max_clone=sizeclone;
				
			  if(sizeclone>1)
			    num_clone++;
			  sizeclone =1;
			  
			  
		   }

	      j--;
	    }
	}
	if(sizeclone<min_clone)
		min_clone=sizeclone;
	else if(sizeclone>max_clone)
		max_clone=sizeclone;
		
	fprintf(g,"%i\t%i\t%i\t%i\n", num_clone, MZsize, max_clone, min_clone);
	
fclose(g);
}  
  
    
